/*
 *  HEsetroot -- Hoppke's Esetroot
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>
#include <dirent.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <Imlib2.h>

#include <unistd.h>
#define _GNU_SOURCE
#include <getopt.h>

void print_help(void) {
printf("Esetroot options:\n\
  -file image_file        Name of image file to load\n\
  [-display display]      X Display to connect to\n\
  [-scale]                Scale the image\n\
  [-center]               Center the image\n\
  [-fit]                  Fit the image\n\
  [-mirror]               Mirror the image\n\n\
  [-logo logo_image]      Blend this image over the wallpaper\n\
  [-lpos X,Y]             Put the logo at [X,Y]\n\
  [-text \"some text\"]     Text to draw\n\
  [-tpos X,Y]             Put the text at [X,Y]\n\
  [-tcolor R,G,B,A]       RGB&Alpha values for the text, [0-255] each\n\
  [-fn /path/font/size]   .ttf to draw text with\n\
  [-help]                 This \"help\"\n\
  ");
}

void randomly_select(char *nazwa) {
	unsigned int z;
	int k,p;
	DIR *katalog;
	struct dirent *struk;
	katalog=opendir(nazwa);
	z=0;
	while((struk=readdir(katalog))) z++;

petla:
	rewinddir(katalog);
	readdir(katalog);
	readdir(katalog);
	p=(rand()%(z-2));
	for (k=0;k<=p;k++) struk=readdir(katalog);
	if (!memcmp(struk->d_name,".",1)) goto petla;

	closedir(katalog);
	strcat(nazwa,"/");
	strcat(nazwa,struk->d_name);
}

void set_pixmap_property(Pixmap p);

Display *Xdisplay;
Screen *scr;
Window Xroot;
int screen;
Imlib_Font font=NULL;

#define Xdepth	 (DefaultDepth(Xdisplay, screen))

	void
set_pixmap_property(Pixmap p)
{

	Atom prop_root, prop_esetroot, type;
	int format;
	unsigned long length, after;
	unsigned char *data_root, *data_esetroot;

	prop_root = XInternAtom(Xdisplay, "_XROOTPMAP_ID", True);
	prop_esetroot = XInternAtom(Xdisplay, "ESETROOT_PMAP_ID", True);


	if (prop_root != None && prop_esetroot != None) {
		XGetWindowProperty(Xdisplay, Xroot, prop_root, 0L, 1L, False, AnyPropertyType,
				&type, &format, &length, &after, &data_root);
		if (type == XA_PIXMAP) {
			XGetWindowProperty(Xdisplay, Xroot, prop_esetroot, 0L, 1L, False, AnyPropertyType,
					&type, &format, &length, &after, &data_esetroot);
			if (data_root && data_esetroot) {

				if (type == XA_PIXMAP && *((Pixmap *) data_root) == *((Pixmap *) data_esetroot)) {
					XKillClient(Xdisplay, *((Pixmap *) data_root));
				}
			}
		}
	}
	/* This will locate the property, creating it if it doesn't exist */
	prop_root = XInternAtom(Xdisplay, "_XROOTPMAP_ID", False);
	prop_esetroot = XInternAtom(Xdisplay, "ESETROOT_PMAP_ID", False);

	/* The call above should have created it.  If that failed, we can't continue. */
	if (prop_root == None || prop_esetroot == None) {
		fprintf(stderr, "Esetroot:  creation of pixmap property failed.\n");
		exit(1);
	}
	XChangeProperty(Xdisplay, Xroot, prop_root, XA_PIXMAP, 32, PropModeReplace,
			(unsigned char *) &p, 1);
	XChangeProperty(Xdisplay, Xroot, prop_esetroot, XA_PIXMAP, 32, PropModeReplace,
			(unsigned char *) &p, 1);

	XSetCloseDownMode(Xdisplay, RetainPermanent);
	XFlush(Xdisplay);
}

int main(int argc, char *argv[])
{
	unsigned int scale = 0, center = 0, fit = 0, mirror = 0;
	char *displayname = NULL;
	char *fn=NULL, *fp=NULL, *lpos=NULL,*tpos=NULL,*tcolor=NULL,*fname=NULL;
  Imlib_Image im, im2=NULL;
  Pixmap p = None, temp_pmap = None, m = None;
  GC gc;
  XGCValues gcv;
  int w, h, x, y;

struct {
	char *file;
	int x;
	int y;
	short int invx;
	short int invy;
	int width;
	int height;
	unsigned char red,green,blue,alpha;
	char *data;
} logo, tekst;

srand(time(NULL)+time(NULL)*1000);
	
logo.file=NULL;
logo.data=NULL;
tekst.file=NULL;
tekst.data=NULL;

  int optc=1;
  int ind;
  int *indeks=&ind;

struct stat file_info;

struct option opcje[]={
	{"file",1,NULL,1},
	{"logo",1,NULL,2},
	{"lpos",1,NULL,3},
	{"tpos",1,NULL,4},
	{"tcolor",1,NULL,5},
	{"display",1,NULL,6},
	{"scale",0,NULL,7},
	{"center",0,NULL,8},
	{"fit",0,NULL,9},
	{"mirror",0,NULL,10},
	{"help",0,NULL,11},
	{"text",1,NULL,12},
	{"fn",1,NULL,13}
};


while ((optc=getopt_long_only(argc,argv,"",opcje,indeks))!=-1){
//	printf("%s%s","option: ",opcje[optc-1].name);
//	if (optarg) {printf("%s%s"," with value: ",optarg);}
//	printf("\n");

    if (optc == 6) {displayname = optarg;}
	else if (optc == 1) {fname=optarg;}
   	else if (optc == 2) {logo.file = optarg;}
	else if (optc == 3) {lpos=optarg;}
	else if (optc == 4) {tpos=optarg;}
	else if (optc == 5) {tcolor=optarg;}
   	else if (optc == 7) {scale = 1;}
   	else if (optc == 8) {center = 1;}
   	else if (optc == 9) {fit = 1;}
   	else if (optc == 10) {mirror = 1;}
   	else if (optc == 11) {print_help();exit(0);}
   	else if (optc == 12) {tekst.data = optarg;}
	else if (optc == 13) {tekst.file=optarg;}
   	else {print_help();exit(2);}
  }
	if (fname==NULL) {print_help();exit(2);}

  if (scale) {center = 0;mirror=0;}


  if (!displayname) {displayname = getenv("DISPLAY");}
  if (!displayname) {displayname = ":0.0";}
  if ((Xdisplay = XOpenDisplay(displayname)) == 0) {
    fprintf(stderr, "%s:  Unable to open display %s\n", *argv, displayname);
    exit(1);
  }
  screen = DefaultScreen(Xdisplay);
  Xroot = RootWindow(Xdisplay, screen);
  scr = ScreenOfDisplay(Xdisplay, screen);

  imlib_context_set_display(Xdisplay);
  imlib_context_set_visual(DefaultVisual(Xdisplay, DefaultScreen(Xdisplay)));
  if (logo.file!=NULL) {
	  
	if (lpos!=NULL) {
	if (lpos[0]=='-') {logo.invx=1;} else {logo.invx=0;}
	logo.x=atoi(strsep(&lpos,","));
	//(char **) ly=strsep(&lpos,",");
	logo.y=atoi(lpos);
	if (lpos[0]=='-') {logo.invy=1;} else {logo.invy=0;}
	
	} else {
		logo.x=0;logo.y=0;logo.invx=0;logo.invy=0;
	}

	  im2 = imlib_load_image_immediately(logo.file);
	  if (im2 == NULL) {fprintf(stderr, "Unable to load logo file \"%s\".\n", fname);}
	  else {
		imlib_context_set_image(im2);
		logo.width=imlib_image_get_width();
		logo.height=imlib_image_get_height();
	  }
  }

stat(fname, &file_info);
if (S_ISDIR(file_info.st_mode)) {randomly_select(fname);}

  im = imlib_load_image_immediately(fname);
  if (im == NULL) {
    fprintf(stderr, "Unable to load image file \"%s\".\n", fname);
    exit(1);
  }
  imlib_context_set_image(im);
  if (scale) {
    w = scr->width;
    h = scr->height;
  } else if (mirror) {
    w = imlib_image_get_width() * 2;
    h = imlib_image_get_height() * 2;
  } else {
    w = imlib_image_get_width();
    h = imlib_image_get_height();
  }
  if (fit) {
    double x_ratio, y_ratio;

    x_ratio = ((double) scr->width) / ((double) w);
    y_ratio = ((double) scr->height) / ((double) h);
    if (x_ratio > y_ratio) {
      x_ratio = y_ratio;
    }
    w = (int) (w * x_ratio);
    h = (int) (h * x_ratio);
  }
  p = XCreatePixmap(Xdisplay, Xroot, scr->width, scr->height, Xdepth);
  gcv.foreground = gcv.background = BlackPixel(Xdisplay, screen);
  gc = XCreateGC(Xdisplay, p, ((center || fit) ? (GCForeground | GCBackground) : 0), &gcv);
  if (scale) {
    XFillRectangle(Xdisplay, p, gc, 0, 0, w, h);
  }
  if (center || fit) {
    XFillRectangle(Xdisplay, p, gc, 0, 0, scr->width, scr->height);
    x = (scr->width - w) >> 1;
    y = (scr->height - h) >> 1;
  } else {
    x = 0;
    y = 0;
  }

  imlib_context_set_anti_alias(1);
  imlib_context_set_dither(1);
  imlib_context_set_blend(1);
if (tekst.data!=NULL) {
	if (tcolor!=NULL) {
	tekst.red=atoi(strsep(&tcolor,","));
	tekst.green=atoi(strsep(&tcolor,","));
	tekst.blue=atoi(strsep(&tcolor,","));
	tekst.alpha=atoi(tcolor);
	} else {
		tekst.alpha=tekst.red=tekst.green=tekst.blue=200;
	}
  imlib_context_set_color(tekst.red,tekst.green,tekst.blue,tekst.alpha);
	if (tpos!=NULL) {
  	if (tpos[0]=='-') {tekst.invx=1;} else {tekst.invx=0;}
	tekst.x=atoi(strsep(&tpos,","));
	tekst.y=atoi(tpos);
	if (tpos[0]=='-') {tekst.invy=1;} else {tekst.invy=0;}
	} else {
		tekst.x=0;tekst.y=0;tekst.invx=0;tekst.invy=1;
	}
if ((strstr(tekst.file,".ttf/")||strstr(tekst.file,".TTF/"))==0) {
	tekst.file=strcat(tekst.file,"/30");
}
	fp=rindex(tekst.file,'/');
	fp[0]='\0';
	fn=rindex(tekst.file,'/');
	fn[0]='\0';
	fn++;
	fp[0]='/';

  imlib_add_path_to_font_path(tekst.file);
  font = imlib_load_font(fn);
  if (font!=NULL) {
imlib_context_set_font(font);
imlib_get_text_advance(tekst.data,&tekst.width,&tekst.height);
if (tekst.invx) {tekst.x+=w-tekst.width;}
if (tekst.invy) {tekst.y+=h-tekst.height;}
  imlib_text_draw(tekst.x,tekst.y,tekst.data);
  imlib_free_font();
  }
}
if (im2!=NULL) {
if (logo.invx) {logo.x+=w-logo.width;}
if (logo.invy) {logo.y+=h-logo.height;}
  imlib_blend_image_onto_image(im2, 0, 0,0,logo.width,logo.height, logo.x, logo.y,logo.width,logo.height);
}
  
  if (mirror) {
    temp_pmap = XCreatePixmap(Xdisplay, Xroot, w, h, Xdepth);
    imlib_context_set_drawable(temp_pmap);
    imlib_render_image_on_drawable(0, 0);
    imlib_image_flip_horizontal();
    imlib_render_image_on_drawable(imlib_image_get_width(), 0);
    imlib_image_flip_vertical();
    imlib_render_image_on_drawable(imlib_image_get_width(), imlib_image_get_height());
    imlib_image_flip_horizontal();
    imlib_render_image_on_drawable(0, imlib_image_get_height());
  } else {
    imlib_context_set_drawable(Xroot);
    imlib_render_pixmaps_for_whole_image_at_size(&temp_pmap, &m, w, h);
  }

  if (temp_pmap != None) {
    if (m) {
      XFreePixmap(Xdisplay, m);
      m = None;
    }
    XSetTile(Xdisplay, gc, temp_pmap);
    XSetTSOrigin(Xdisplay, gc, x, y);
    XSetFillStyle(Xdisplay, gc, FillTiled);
    if (center || fit) {
      XFillRectangle(Xdisplay, p, gc, x, y, w, h);
    } else {
      XFillRectangle(Xdisplay, p, gc, x, y, scr->width, scr->height);
    }
    set_pixmap_property(p);
    XFlush(Xdisplay);
    XSetWindowBackgroundPixmap(Xdisplay, Xroot, p);
    XClearWindow(Xdisplay, Xroot);
    XFlush(Xdisplay);
  }
  return 0;
}
